using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace spring16_2sem_winudpchat02
{
    public partial class Form1 : Form
    {
        // server
        static public UdpClient server;
        static public IPEndPoint rxpoint;
        // client
        static public UdpClient client;
        static public IPEndPoint txpoint;
        // global variables
        static public int rxport, txport;
        static public string myip, remip;

        delegate void SetTextCallBack(string text);

        public Form1()
        {
            InitializeComponent();
            //get my own ipaddress
            string hostname = Dns.GetHostName();
 
            IPHostEntry local = Dns.GetHostEntry(hostname);
            foreach (IPAddress ipa in local.AddressList)
                textBox2.Text = ipa.ToString();
            textBox4.Text = "6000";
            textBox5.Text = "6001";
        }

        //server code
        private void WaitForDataFromClient()
        {
            while (true)
            {
                //receive data from the client
                byte[] ClientData = server.Receive(ref rxpoint);

                //display on the listbox
                ListBoxDisplay("Server received : " + (System.Text.Encoding.ASCII.GetString(ClientData)));

                //and echo back
                ListBoxDisplay("Sending back");
                server.Send(ClientData, ClientData.Length, rxpoint);
            }
        }

        private void WaitForDataFromServer()
        {
            while (true)
            {
                //receive data from server
                byte[] rxdata = client.Receive(ref txpoint);
                ListBoxDisplay("Client recieved : " + System.Text.Encoding.ASCII.GetString(rxdata));
            }
        }

        private void ListBoxDisplay(string message)
        {
            this.SetListBox(message);
        }

        private void SetListBox(string strText)
        {
            if (listBox1.InvokeRequired)
            {
                SetTextCallBack d = new SetTextCallBack(SetListBox);
                this.Invoke(d, new object[] { strText });
            }
            else
            {
                this.listBox1.Items.Add(strText);
            }
        }

        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                //create a string datagram packet
                string packet = textBox1.Text;
                //convert packet to array of bytes
                byte[] sendData = System.Text.Encoding.ASCII.GetBytes(packet);
                //send to server on port 5001
                client.Send(sendData, sendData.Length, remip, txport);
                //clear textbox
                textBox1.Clear();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //Start
            // textbox2 = my ipaddress
            // textbox3 = remote ipaddress
            // textbox4 = rx port
            // textbox5 = tx port
            rxport = Convert.ToInt32(textBox4.Text);
            txport = Convert.ToInt32(textBox5.Text);
            myip = textBox2.Text;
            remip = textBox3.Text;
            // server
            server = new UdpClient(rxport);
            rxpoint = new IPEndPoint(new IPAddress(0), 0);
            // client
            client = new UdpClient(txport);
            txpoint = new IPEndPoint(new IPAddress(0), 0);

            //start server
            Thread serverThread = new Thread(new ThreadStart(WaitForDataFromClient));
            serverThread.Start();
            //start client
            Thread clientThread = new Thread(new ThreadStart(WaitForDataFromServer));
            clientThread.Start();
        }
    }
}